package {
	import com.greensock.TweenMax;
	import com.greensock.easing.Quad;
	
	import flash.display.Bitmap;
	import flash.events.MouseEvent;
	
	import org.papervision3d.materials.BitmapMaterial;
	import org.papervision3d.materials.ColorMaterial;
	import org.papervision3d.materials.utils.MaterialsList;
	import org.papervision3d.objects.primitives.Cube;
	import org.papervision3d.view.BasicView;
	
	public class pv3dCube1 extends BasicView
	{	
		[Embed(source="/assets/1256710495196.jpg")]
		private var frontAsset:Class;
 
		[Embed(source="/assets/1256710547111.jpg")]
		private var backAsset:Class;
 
		[Embed(source="/assets/1256710591019.jpg")]
		private var leftAsset:Class;
 
		[Embed(source="/assets/1256710711042.jpg")]
		private var rightAsset:Class;
		
		private var cube:Cube;		
		private var mouseDownX:Number = 0;
		private var targetRotation:Number = 0;

		public function pv3dCube1()
		{
			super(500, 250);
 
			opaqueBackground = 0x000000;
			camera.focus = 100;
			camera.zoom = 10;
 
			var materialsList:MaterialsList = new MaterialsList();
			materialsList.addMaterial(createBitmapMaterialFromAsset(frontAsset), "front");
			materialsList.addMaterial(createBitmapMaterialFromAsset(backAsset), "back");
			materialsList.addMaterial(createBitmapMaterialFromAsset(leftAsset), "left");
			materialsList.addMaterial(createBitmapMaterialFromAsset(rightAsset), "right");
			materialsList.addMaterial(new ColorMaterial(0xffffff), "top");
			materialsList.addMaterial(new ColorMaterial(0xffffff), "bottom");
 
			cube = new Cube(materialsList, 500, 500, 250);
			cube.z = 250;
			scene.addChild(cube);
 
			startRendering();
 
			addEventListener(MouseEvent.MOUSE_DOWN, mouseDownHandler);
			addEventListener(MouseEvent.MOUSE_UP, mouseUpHandler);
		}
		private function createBitmapMaterialFromAsset(asset:Class):BitmapMaterial
		{
			var bitmap:Bitmap = new asset() as Bitmap;
			var material:BitmapMaterial = new BitmapMaterial(bitmap.bitmapData, true);
 
			return material;
		}
 
		private function mouseDownHandler(event:MouseEvent):void
		{
			mouseDownX = event.localX;
		}
 
		private function mouseUpHandler(event:MouseEvent):void
		{
			var currentMouseX:Number = event.localX;
			if(currentMouseX < mouseDownX) targetRotation += 90;
			else targetRotation -= 90;
			TweenMax.to(cube, .5, {rotationY:targetRotation, z:250, bezierThrough:[{z:900}], ease:Quad.easeInOut});
		}
	}
}